<?php

namespace Drupal\build_hooks_test\Plugin\FrontendEnvironment;

use Drupal\build_hooks\BuildHookDetails;
use Drupal\build_hooks\Plugin\FrontendEnvironmentBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Defines a test environment plugin.
 *
 * @FrontendEnvironment(
 *  id = "build_hooks_test",
 *  label = "Test environment",
 *  description = "Test environment."
 * )
 */
class TestEnvironment extends FrontendEnvironmentBase {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration() {
    return parent::defaultConfiguration() + ['whiz' => 'whang'];
  }

  /**
   * {@inheritdoc}
   */
  public function getBuildHookDetails() {
    $details = new BuildHookDetails();
    $details->setBody([
      'hi' => 'there',
    ]);
    $details->setMethod('POST');
    $details->setUrl('http://example.com?whiz=' . $this->configuration['whiz']);
    return $details;
  }

  /**
   * {@inheritdoc}
   */
  public function getAdditionalDeployFormElements(FormStateInterface $form_state) {
    return [[
      '#markup' => '<h3>Hi there</h3>',
    ]];
  }

}
